
window.addEventListener("click", onDownloadSelect, false);

function onDownloadSelect(aEvent)
{
  if (gDownloadsView.selected || gDownloadsView.selectedItem) {
    if (gDownloadsView.selected)
      var st = parseInt(gDownloadsView.selected.getAttribute("state"));
    else var st = parseInt(gDownloadsView.selectedItem.getAttribute("state"));

    if (st < 0)
      st = 0;

    switch (st) {
    case 0:  // Downloading
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 1:  // Done
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmLaunchButton").disabled = false;
      document.getElementById("dmShowButton").disabled = false;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton2").disabled = false;
      document.getElementById("dmShowButton2").disabled = false;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 2:  // Failed
    case 3:  // Canceled
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 4:  // Paused
      document.getElementById("dmStartButton").disabled = false;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = false;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    case 7:  // Install Done
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      document.getElementById("dmCleanUpButton").disabled = false;
      document.getElementById("dmCleanUpButton2").disabled = false;
      break;
    default:
      document.getElementById("dmStartButton").disabled = true;
      document.getElementById("dmLaunchButton").disabled = true;
      document.getElementById("dmShowButton").disabled = true;
      document.getElementById("dmStartButton2").disabled = true;
      document.getElementById("dmLaunchButton2").disabled = true;
      document.getElementById("dmShowButton2").disabled = true;
      break;
    }
  }
}

function dmInit()
{
  var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

  try {

  var bottom = preferencesService.getBoolPref("extensions.downloadmgr.bottomToolBar");
  if (bottom) document.getElementById("topToolBar").hidden="true";
  else document.getElementById("bottomToolBar").hidden="true";

  var dlButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonDownload");
  if (!dlButton) {
	document.getElementById("dmStartButton").hidden="true";
	document.getElementById("dmStartButton2").hidden="true";
	document.getElementById("dmStartSep").hidden="true";
	document.getElementById("dmStartSep2").hidden="true";
  }

  var launchButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonLaunch");
  if (!launchButton) {
	document.getElementById("dmLaunchButton").hidden="true";
	document.getElementById("dmLaunchButton2").hidden="true";
	document.getElementById("dmLaunchSep").hidden="true";
	document.getElementById("dmLaunchSep2").hidden="true";
  }

  var showButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonShow");
  if (!showButton) {
	document.getElementById("dmShowButton").hidden="true";
	document.getElementById("dmShowButton2").hidden="true";
	document.getElementById("dmShowSep").hidden="true";
	document.getElementById("dmShowSep2").hidden="true";
  }

  var cleanButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonClean");
  if (!cleanButton) {
	document.getElementById("dmCleanUpButton").hidden="true";
	document.getElementById("dmCleanUpButton2").hidden="true";
  }

  var optionsButton = preferencesService.getBoolPref("extensions.downloadmgr.buttonOptions");
  if (!optionsButton) {
	document.getElementById("dmOptionsButton").hidden="true";
	document.getElementById("dmOptionsButton2").hidden="true";
  }
  } catch (e) {}
}

function buildContextMenu2(aEvent)
{
  if (aEvent.target.id != "downloadContextMenu")
    return;

  var popup = document.getElementById("downloadContextMenu");
  while (popup.hasChildNodes())
    popup.removeChild(popup.firstChild);

  if (gDownloadsView.selected) {
    var idx = parseInt(gDownloadsView.selected.getAttribute("state"));
    if (idx < 0)
      idx = 0;

    var menus = gContextMenus[idx];
    for (var i = 0; i < menus.length; ++i)
      popup.appendChild(document.getElementById(menus[i]).cloneNode(true));

    return true;
  }

  return false;
}
